//Time Base Forcer, Gijs Gieskes 2010.
//http://gieskes.nl/visual-equipment/?file=time-base-forcer
//this is V3 of the tvout lib, with some extra functions.
//tvout project page: http://code.google.com/p/arduino-tvout/

#include "TVoutTBF.h"

byte capture[2][128]; 

int pot[6];

TVout TV;
int x,y, audio, AV2;

boolean modeSelect = true;

boolean BA = 0;
boolean BB = 0;
boolean BC = 0;
boolean BD = 0;

boolean BI = 0;
boolean prevBI = 1;
boolean BAUDIO = 0;

byte prevP = 255;

byte px = 0;
byte py = 0;

int CA = 0;
byte PV = 0;
byte PT = 2;

void setup()  {
  
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  
  pinMode(13, INPUT);
  digitalWrite(13, HIGH);
  
  //select pal or ntsc
  pinMode(19, INPUT);
  digitalWrite(19, HIGH);
  delay(1);
  if(digitalRead(19)){  
    TV.start_render(_PAL);
  }else{
    TV.start_render(_NTSC);
  }
  
  //fill screen with white
  for(byte x=0; x<104; x++){
    TV.draw_line(0, x, 127, x, 1);  
  }
  
}

void loop() {
  
  audioIn();
  
  readAnalogs();
  
  //vertical scroll
  TV.scan_line((pot[1] >> 6)+305);
  
  AV2 = pot[2] >> 7;
  
  switch (AV2){
    case 0:
      patch11();
      break;
    case 1:
      patch14();
      break;
    case 2:
      patch20();
      break;
    case 3:
      patch8();
      break;
    case 4:
      patch15();
      patch0();
      break;
    case 5:
      patch24();
      break;
    case 6:
      patch23();
      break;
    case 7:
      patch22();
      break;
  }
}

inline void patch24(){
  
  if(prevP != AV2){
    prevP = AV2;
    BAUDIO = false;
  }
  
  if(audio < 150){
    BAUDIO = true;
  }
  
  if(!digitalRead(13)){
    if(!BAUDIO){
      for(x=0; x<1664; x++){
        x += pot[3] >> 6;
        TV.set_byte(x, x%255);
      }
    }else{
      for(x=0; x<1664; x++){
        TV.set_byte(x, 255);
      }
    }
  }
  
  byte limit = pot[3] >> 6;
  
  if(audio < 200){
    for(x=0; x<1664; x++){
      TV.set_byte(x, 255);
    }
  }
  
  CA = cup(CA, limit);
  
  if(!CA){
    TV.fade(limit, 3);
  }
}

//lammelle fade
inline void patch23(){
  
  if(prevP != AV2){
    prevP = AV2;
    BAUDIO = false;
  }
  
  if(audio < 150){
    BAUDIO = true;
  }
  
  inverter();
  
  int limit = constrain(audio, 24, pot[3] >> 1);
  if(BAUDIO){
    limit = map(limit, 24, pot[3] >> 1, 0, 9);
  }else{
    limit = map(pot[3] >> 1, 0, 512, 0, 9);
  }
  
  for(x=0; x<1664; x++){
    TV.set_byte(x, (B11111111 >> limit));
  }
}

//swipe fade
inline void patch22(){
  
  if(prevP != AV2){
    prevP = AV2;
    BAUDIO = false;
  }
  
  if(!digitalRead(13)){
    if(!prevBI){
      prevBI = true;
      BI = !BI;
    }
  }else{
    prevBI = false;
  }
  
  if(audio < 150){
    BAUDIO = true;
  }
  
  if(!BAUDIO){
    CA = map(pot[3], 0, 1023, 1664, 0);
  }else{
    audio = min(audio, 512);
    audio = 1664 - ((audio + (audio << 1)+130));
    if(audio > CA){
      CA = audio;
    }else{
      CA -= pot[3] >> 2;
      CA = max(CA, 0);
    }
  }
  
  if(BI){
    for(x=0; x<1664; x++){
      if(x > CA){
        TV.set_byte(x, 255);
      }else{
        TV.set_byte(x, 0);
      }
    }
  }else{
    for(x=0; x<1664; x++){
      if(x > CA){
        TV.set_byte(x, 0);
      }else{
        TV.set_byte(x, 255);
      }
    }
  }
}


//cross bounce around..
inline void patch8(){
  
  if(prevP != AV2){
    prevP = AV2;
  }
  
  inverter();
  
  //audio = constrain(audio, 25, 766);
  //audio = map(audio, 26, 766, 0, 110);
  audio = constrain(audio, 300, 723);
  audio = map(audio, 300, 723, 0, 110);
   
  if(BI){
    TV.draw_line(pot[3] >> 3, audio, 127, audio, 0);
  }else{
    TV.draw_line(0, audio, pot[3] >> 3, audio, 0);
  }
  
  if(x > 126 || TV.get_pixel(x+1, y, 1) == 1){
    BA = false;
  }
    
  if(x < 1 || TV.get_pixel(x-1, y, 1) == 1){
    BA = true;
  }
    
  if(y > 103 || TV.get_pixel(x, y+1, 1) == 1){
    BB = false;
  }
    
  if(y < 1 || TV.get_pixel(x, y-1, 1) == 1){
    BB = true;
  }
    
  if(BA){
    x++;
  }else{
    x--;
  }
    
  if(BB){
    y++;
  }else{
    y--;
  }
  
  px = x;
  py = y;
  TV.set_pixel(px, py, 1);
  
}


//snow
void patch15(){
  
  if(prevP != AV2){
    prevP = AV2;
  }
  
  px++;
  if(px >= 127){
   px = 0;
  } 
  
  if(audio > 650){
    //clear old snow for new snow..
    TV.set_pixel(capture[0][px], capture[1][px], 0);
    capture[0][px] = px;
    capture[1][px] = 0;
  }

  if(capture[1][px] < 95){
    TV.set_pixel(capture[0][px], capture[1][px], 0);
    capture[1][px] += ((1023 - pot[3]) >> 8)+1;
    TV.set_pixel(capture[0][px], capture[1][px], 1);
  }else{
    TV.set_pixel(capture[0][px], capture[1][px], 0);
  }
}


void patch0(){
  
  if(prevP != AV2){
    prevP = AV2;
  }
  
  if(!digitalRead(13)){
    BI = !BI;
  }
  
  if(BI){
    //horizontal 1
    if(BA){
      y = cup(y, 104);
      BA = false;
    }else{
      x = cup(x, 127);
      if(!x){
        BA = true;
      }
    }
  
    CA = audio >> 3;
    CA = constrain(CA, 0, 140);
    if(CA > y){
      TV.set_pixel(x, y, 1);
    }else{
      TV.set_pixel(x, y, 0);
    }
  }
}


void patch20(){
  //scrolling square
  
  if(prevP != AV2){
    prevP = AV2;
  }
  
  if(!digitalRead(13)){
    PV = cup(PV, 4);
    while(!digitalRead(13)){}; 
  }
  
  if(PV == 0){
    
    CA = pot[3] >> 4;
    TV.scroll((64-CA), 0, 63+CA, 103, BA);
    
  }else if(PV == 1){
    
    CA = pot[3] >> 3;
    TV.scroll(0, min(CA, 103), 127, min(6+CA, 103), BA); 
    
  }else if(PV == 2){
    
    CA = pot[3] >> 3;
    TV.scroll(CA, 0, min(CA+1, 127), 103, BA); 
    
  }else if(PV == 3){
    
    if(x == 127 || x == 0 || audio < 200){
      BB = !BB;
    }
    
    if(BB){
      x = cup(x, 128);
    }else{
      if(x){
        x--;
      }
    }
    
    TV.scroll(x, 0, min(x+1, 127), 103, 1);
    
  }
}

void patch14(){
  //ant farm
  
  px = x;
  py = y;
  
  if(CA == 0){
    y++;
    y %= 95;
  }else if(CA == 1){
    y++;
    y %= 95;
    x++;
    x %= 127;
  }else if(CA == 2){
    x++;
    x %= 127;
  }else if(CA == 3){
    x++;
    x %= 127;
    y--;
    if(y < 0){
      y = 95; 
    }
  }else if(CA == 4){
    y--;
    if(y < 0){
      y = 95; 
    }
  }else if(CA == 5){
    y--;
    if(y < 0){
      y = 95; 
    }
    x--;
    if(x < 0){
      x = 127; 
    }
  }else if(CA == 6){
    x--;
    if(x < 0){
      x = 127; 
    }
  }else if(CA == 7){
    x--;
    if(x < 0){
      x = 127; 
    }
    y++;
    y %= 95;
  }
  
  if(TV.get_pixel(x, y, 1) == 1){
    CA++;
    CA %= 8;
    if(!random(4)){
      CA = random(8);
    }
  }
  
  TV.set_pixel(px, py, 0);
  TV.set_pixel(x, y, 1);
  
  if(!digitalRead(13)){
    PT = cup(PT, 3);
    while(!digitalRead(13)){} 
  }
 
  if(pot[3] > 512){
    if(audio > 650){
      capture[0][0] = cup(capture[0][0], 104);
      TV.draw_line(0,  capture[0][0], 127,  capture[0][0], PT);
    }
  }else{ 
    if(audio > 650){
      capture[0][0]--;
      if(capture[0][0] < 1){
        capture[0][0] = 104;
      }
      TV.draw_line(0,  capture[0][0], 127,  capture[0][0], PT);
    }
  }
  
  TV.delay_frame(1); 

}


void patch11(){
  
  if(prevP != AV2){
    prevP = AV2;
  }
  
  if(!digitalRead(13)){
    PT = cup(PT, 3);
    while(!digitalRead(13)){} 
  }
  
  if(audio > 650){
    py = cup(py, 95);
    TV.draw_line(0,  py, 127,  py, PT);
  }
  
  x = cup(x, 126);
  if(!x){
    BA = !BA;
  }
  if(BA){
    y = cup(y, 95);
  }else{
    y--;
    if(y < 0){
      y = 95;
    }
  }
  
  byte AV3 = pot[3] >> 4;
  byte AV3S = AV3 >> 5;
  
  if(TV.get_pixel(x+1, y, AV3S) == 0){
    TV.set_pixel(min(127, x+1), y, bitRead(AV3, 0));
  }
  if(TV.get_pixel(x-1, y, AV3S) == 0){
    TV.set_pixel(max(0, x-1), y, bitRead(AV3, 1));
  }
  if(TV.get_pixel(x, y+1, AV3S) == 0){
    TV.set_pixel(x, min(95, y+1), bitRead(AV3, 2));
  }
  if(TV.get_pixel(x, y-1, AV3S) == 0){
    TV.set_pixel(x, max(0, y-1), bitRead(AV3, 3));
  }
  if(TV.get_pixel(x-1, y-1, AV3S) == 0){
    TV.set_pixel(max(0, x-1), max(0, y-1), bitRead(AV3, 4));
  }  
  if(TV.get_pixel(x+1, y+1, AV3S) == 0){
    TV.set_pixel(min(127, x+1), min(95, y+1), bitRead(AV3, 5));
  }
  
}


//audio in and menu
void audioIn(){
  static unsigned long prevMillis = 0;
  static byte prevState2 = 255;
  
  if(AV2 != prevState2){
    prevState2 = AV2;
    prevMillis = millis();
  }
  
  audio = constrain(analogRead(0), 26, 766);
    
  if(millis() < (prevMillis + 2000)){
    digitalWrite(6, bitRead(AV2, 0));
    digitalWrite(5, bitRead(AV2, 1));
    digitalWrite(4, bitRead(AV2, 2));
  }else{
    
    if(audio < 200){
      digitalWrite(6, HIGH);
    }else{
      digitalWrite(6, LOW);
    } 
    if(audio < 350){
      digitalWrite(5, HIGH);
    }else{
      digitalWrite(5, LOW);
    }
    if(audio < 500){
      digitalWrite(4, HIGH);
    }else{
      digitalWrite(4, LOW);
    }
  }
  
}

inline static int cup(int a, int b){
  a++;
  if(a >= b){
    a = 0;
  }
  return a;
} 

inline void readAnalogs(){
  static byte potc = 0;

  potc++;
  if(potc > 3){
    potc = 1;
  }
  pot[potc] = analogRead(potc);
}

inline void inverter(){
  if(!digitalRead(13)){
    TV.invert();
    BI = !BI;
  } 
}

